3.0.0-beta09 (latest) 3.0.0-beta08 2.0.0-beta08

    public sealed class HttpRequest : IMessage<HttpRequest>, IEquatable<HttpRequest>, IDeepCloneable<HttpRequest>, IBufferMessage, IMessage

Reference documentation and code samples for the Google Cloud Tasks v2beta3 API class HttpRequest.

HTTP request.

The task will be pushed to the worker as an HTTP request. If the worker
or the redirected worker acknowledges the task by returning a successful HTTP
response code (\[`200` - `299`\]), the task will be removed from the queue. If
any other HTTP response code is returned or no response is received, the
task will be retried according to the following:

- User-specified throttling: \[retry
  configuration\]\[google.cloud.tasks.v2beta3.Queue.retry_config\],
  \[rate limits\]\[google.cloud.tasks.v2beta3.Queue.rate_limits\], and the
  \[queue's state\]\[google.cloud.tasks.v2beta3.Queue.state\].

- System throttling: To prevent the worker from overloading, Cloud Tasks may
  temporarily reduce the queue's effective rate. User-specified settings
  will not be changed.

  System throttling happens because:
  - Cloud Tasks backs off on all errors. Normally the backoff specified in
    \[rate limits\]\[google.cloud.tasks.v2beta3.Queue.rate_limits\] will be used.
    But if the worker returns `429` (Too Many Requests), `503` (Service
    Unavailable), or the rate of errors is high, Cloud Tasks will use a
    higher backoff rate. The retry specified in the `Retry-After` HTTP
    response header is considered.

  - To prevent traffic spikes and to smooth sudden increases in traffic,
    dispatches ramp up slowly when the queue is newly created or idle and
    if large numbers of tasks suddenly become available to dispatch (due to
    spikes in create task rates, the queue being unpaused, or many tasks
    that are scheduled at the same time).

## Inheritance

[object](https://learn.microsoft.com/dotnet/api/system.object) \> HttpRequest

## Implements

[IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage-1.html)[HttpRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpRequest), [IEquatable](https://learn.microsoft.com/dotnet/api/system.iequatable-1)[HttpRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpRequest), [IDeepCloneable](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IDeepCloneable-1.html)[HttpRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpRequest), [IBufferMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IBufferMessage.html), [IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage.html)

## Inherited Members

[object.GetHashCode()](https://learn.microsoft.com/dotnet/api/system.object.gethashcode) [object.GetType()](https://learn.microsoft.com/dotnet/api/system.object.gettype) [object.ToString()](https://learn.microsoft.com/dotnet/api/system.object.tostring)

## Namespace

[Google.Cloud.Tasks.V2Beta3](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3)

## Assembly

Google.Cloud.Tasks.V2Beta3.dll

## Constructors

### HttpRequest()

    public HttpRequest()

### HttpRequest(HttpRequest)

    public HttpRequest(HttpRequest other)

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `other` | `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpRequest` |

## Properties

### AuthorizationHeaderCase

    public HttpRequest.AuthorizationHeaderOneofCase AuthorizationHeaderCase { get; }

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpRequesthttps://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpRequest.AuthorizationHeaderOneofCase` |   |

### Body

    public ByteString Body { get; set; }

HTTP request body.

A request body is allowed only if the
\[HTTP method\]\[google.cloud.tasks.v2beta3.HttpRequest.http_method\] is POST,
PUT, or PATCH. It is an error to set body on a task with an incompatible
\[HttpMethod\]\[google.cloud.tasks.v2beta3.HttpMethod\].

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.ByteString.html` |   |

### Headers

    public MapField<string, string> Headers { get; }

HTTP request headers.

This map contains the header field names and values.
Headers can be set when the
\[task is created\]\[google.cloud.tasks.v2beta3.CloudTasks.CreateTask\].

These headers represent a subset of the headers that will accompany the
task's HTTP request. Some HTTP request headers will be ignored or replaced.

A partial list of headers that will be ignored or replaced is:

- Any header that is prefixed with "X-CloudTasks-" will be treated as service header. Service headers define properties of the task and are predefined in Cloud Tasks.
- Host: This will be computed by Cloud Tasks and derived from \[HttpRequest.url\]\[google.cloud.tasks.v2beta3.HttpRequest.url\].
- Content-Length: This will be computed by Cloud Tasks.
- User-Agent: This will be set to `"Google-Cloud-Tasks"`.
- `X-Google-*`: Google use only.
- `X-AppEngine-*`: Google use only.

`Content-Type` won't be set by Cloud Tasks. You can explicitly set
`Content-Type` to a media type when the
\[task is created\]\[google.cloud.tasks.v2beta3.CloudTasks.CreateTask\].
For example, `Content-Type` can be set to `"application/octet-stream"` or
`"application/json"`.

Headers which can have multiple values (according to RFC2616) can be
specified using comma-separated values.

The size of the headers must be less than 80KB.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.Collections.MapField-2.htmlhttps://learn.microsoft.com/dotnet/api/system.stringhttps://learn.microsoft.com/dotnet/api/system.string` |   |

### HttpMethod

    public HttpMethod HttpMethod { get; set; }

The HTTP method to use for the request. The default is POST.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpMethod` |   |

### OauthToken

    public OAuthToken OauthToken { get; set; }

If specified, an
[OAuth token](https://developers.google.com/identity/protocols/OAuth2)
will be generated and attached as an `Authorization` header in the HTTP
request.

This type of authorization should generally only be used when calling
Google APIs hosted on \*.googleapis.com.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.OAuthToken` |   |

### OidcToken

    public OidcToken OidcToken { get; set; }

If specified, an
[OIDC](https://developers.google.com/identity/protocols/OpenIDConnect)
token will be generated and attached as an `Authorization` header in the
HTTP request.

This type of authorization can be used for many scenarios, including
calling Cloud Run, or endpoints where you intend to validate the token
yourself.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.OidcToken` |   |

### Url

    public string Url { get; set; }

Required. The full url path that the request will be sent to.

This string must begin with either "http://" or "https://". Some examples
are: `http://acme.com` and `https://acme.com/sales:8080`. Cloud Tasks will
encode some characters for safety and compatibility. The maximum allowed
URL length is 2083 characters after encoding.

The `Location` header response from a redirect response \[`300` - `399`\]
may be followed. The redirect is not counted as a separate attempt.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.string` |   |